#Practice of scraping
#by Qi 2010.10.26

import re

#Fetch the all string matched. Return a list.
def regexmatch(rule,str):
    '''Fetch the all string matched. Return a list.'''
    p = re.compile(rule)
    return p.findall(str)
#end def regexmatch


import urllib2

#Fetch the target html
def gethtml(url):
    '''Fetch the target html'''
    try:
        response = urllib2.urlopen(url)
        return  response.read()
    except URLError, e:
        if hasattr(e, 'reason'):
            print 'Failed to reach a server.'
            print 'Reason: ', e.reason
        elif hasattr(e, 'code'):
            print 'The server couldn\'t fulfill the request.'
            print 'Error code: ', e.code
    
#end def gethtml


#decodeHtmlEntity
def decodeHtmlEntity(s) :
    '''decodeHtmlEntity'''
    result = s
    entityRe = '(&#(\\d{5});)'
    entities = re.findall(entityRe, s)
    for entity in entities :
        result = result.replace(entity[0], unichr(int(entity[1])))
    result=result.replace('&nbsp;',' ')
    
    return result
#end def decodeHtmlEntity


#Fetch menupalace.com's html
html=gethtml('http://menupalace.com')

print 'Fetching html from http://menupalace.com ...'

# fetch the two country list
rule = r'''<table width="100%" border="0" cellspacing="0" cellpadding="0" class="n_table">([\s\S]*?)</table>'''

result = regexmatch(rule,html)

#final result
dining_db = []

for item in result:

    #fetch city name
    r = regexmatch(r'''<img src="images/MP_logoBullet.jpg" width="17" height="17" align="top" />([\s\S]*?)</td>''',item)

    if len(r)>=1:
        country=r[0].strip()

    #fetch link
    r=regexmatch(r'''<a href="([ \S]*?)" class="smallP">([ \S]*?)</a>''',item)

    for n in r:

        #city name
        city=n[1].strip()
        
        #fetch details
        if len(n[0])>7:
            html=gethtml(n[0])

            print 'Fetching html from ',n[0],' ...'            

            r1=regexmatch(r'''<table width="100%" border="0" cellspacing="0" cellpadding="0">([\s\S]*?)</table>''',html)

            for  i in r1:
                #name r2[0]
                r2=regexmatch(r'''<span id="ctl00_ContentPlaceHolder1_\S*side_CompanyName">([ \S]*?)</span>''',i)
                #address r3[0]
                r3=regexmatch(r'''<span id="ctl00_ContentPlaceHolder1_feature_\S*side_Address">([ \S]*?)</span>''',i)
                #website r4[0]
                r4=regexmatch(r'''<span id="ctl00_ContentPlaceHolder1_feature_\S*side_Website">([ \S]*?)</span>''',i)

                    
                if len(r2)>0 and len(r3)>0 and len(r4)>0:
                    dining = {}
                    dining['name'] = decodeHtmlEntity(r2[0])
                    dining['address'] = decodeHtmlEntity(r3[0])
                    dining['city'] = city
                    dining['state'] = city
                    dining['country'] = country
                    dining['website'] = r4[0]
                    dining_db.append(dining)                

                if len(r2)==0 and len(r3)==0 and len(r4)==0:
                    #name r2[0]
                    r2=regexmatch(r'''<!-- InstanceBeginEditable name="featuredRestaurantName" --><a [ \S]*?><img [ \S]*?/> ([ \S]*?)</a><!-- InstanceEndEditable -->''',i)
                    #address r3[0]
                    r3=regexmatch(r'''<!-- InstanceBeginEditable name="featuredRestaurantAddress" --><p class="featuredRestP">([ \S]*?) </p><!-- InstanceEndEditable -->''',i)
                    #website r4[0]
                    r4=regexmatch(r'''<!-- InstanceBeginEditable name="featuredRestaurantURL" --><a [ \S]*?>([ \S]*?)</a><!-- InstanceEndEditable -->''',i)
                    
                 
                    if len(r2)>0 and len(r3)>0 and len(r4)>0:                    
                        dining = {}
                        dining['name'] = decodeHtmlEntity(r2[0])
                        dining['address'] = decodeHtmlEntity(r3[0])
                        dining['city'] = city
                        dining['state'] = city
                        dining['country'] = country
                        dining['website'] = r4[0]
                        dining_db.append(dining)                           
                



#print and save the final result
import csv
cf = open("scraping_result.csv", "w")
writer = csv.writer(cf)
writer.writerow(['name','address','city','state','country','website'])

for  item in dining_db:
     #print item['name'],item['address'],item['city'],item['state'],item['country'],item['website']
     rlist=[]
     rlist.append(item['name'])
     rlist.append(item['address'])
     rlist.append(item['city'])
     rlist.append(item['state'])
     rlist.append(item['country'])
     rlist.append(item['website'])
     writer.writerow(rlist)

cf.close()


print 'The result has been saved into scraping_result.csv!'


     